import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.support.ConnectionSource;

import java.sql.SQLException;

public class AccountApp {

    private Dao<Account, Integer> accountDao;

    private void setupDao(ConnectionSource connectionSource) throws Exception {
        accountDao = DaoManager.createDao(connectionSource,Account.class);
    }
    // we are using a MySQl database
    private final static String DATABASE_URL = "jdbc:mysql://localhost:3306/orm_lab?useUnicode=true";
    private Console c = new Console();

    public static void main(String[] args) throws Exception {
        // turn our static method into an instance of Main
        new AccountApp().doMain(args);
    }

    private void doMain(String[] args) throws Exception {
        ConnectionSource connectionSource = null;

        try{
            // create data-source for db
            connectionSource = new JdbcConnectionSource(DATABASE_URL,"root","");
            setupDao(connectionSource);
            processData();
        } finally {
            c.goodByeAll();
            if (connectionSource !=null){
                connectionSource.close();
            }
        }
    }

    /**
     * Read and write some example data.
     */
    private void processData() throws Exception {
        // create an instance of Account
        AccountService accountService = new AccountService(accountDao);

        boolean continueMenu = true;
        System.out.println("This is the Database Manager!\n");

        while (continueMenu){
            c.printMenu();
            c.printingOutAStringInput("Select by the number: ");

           switch (c.nextInt()){

            case 1:

                Account creatingAcc = accountService.createNewAccount();
                accountService.create(creatingAcc);
                break;
            case 2:

                accountService.readingAllTheAccounts(accountService.read());
                break;
            case 3:

                accountService.fullUppdatingMenu();
                break;

            case 4:
                   accountService.deleteEverythingInTheMenu();
                   break;

            default:
                continueMenu = false;

            }

        }
    }

}