import com.j256.ormlite.dao.Dao;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import java.sql.SQLException;

public class AccountServiceTest {

    AccountService testservice;
    Dao<Account, Integer> dao;
    Account acc;

    @Before
    public void setup(){
        dao = new MockDao();
        testservice = new AccountService(dao);
        acc = new Account("Osomatsu","Matsuno");

    }
    @Test
    public void testCreate() throws Exception {
        int exp = 323;
        int actual = testservice.create(new Account("Todomatsu", "Matsuno"));
        Assert.assertEquals(exp,actual);
    }

    @Test
    public void testUpdate() throws SQLException {

        String name = "Todomatsu";

        acc.setName(name);
        int actual = dao.update(acc);

        Assert.assertEquals(640,actual);
    }

    @Test
    public void testDelete() throws Exception {
        int actual = testservice.deletingOneAcc(acc);
        Assert.assertEquals(433, actual);
    }

    @Test
    public void testIdupdate() throws Exception{

        int id = 234;
        acc.setId(id);
        int actual = dao.updateId(acc,id);


        Assert.assertEquals(234,actual);

    }


}
